/// <reference types="react" />
import { CompletionSource } from "@codemirror/autocomplete";
import { Extension } from "@codemirror/state";
import { EngraftContext, EngraftPromise, ReferenceCollection, Tool, ToolProgram, ToolResult, UpdateProxy, VarBindings } from "@engraft/toolkit";
export type SubPrograms = {
    [id: string]: ToolProgram;
};
export declare function hookFancyCodeEditor(props: {
    code: string;
    subPrograms: SubPrograms;
    varBindings: VarBindings;
    context: EngraftContext;
}): {
    subResults: {
        [x: string]: ToolResult<ToolProgram>;
    };
    referenceValuesP: EngraftPromise<{
        [x: string]: unknown;
    }>;
};
export declare function collectReferencesForFancyCodeEditor(code: string, subPrograms: SubPrograms): ReferenceCollection;
type FancyCodeEditorProps = {
    context: EngraftContext;
    extensions?: Extension[];
    defaultCode: string | undefined;
    code: string;
    codeUP: UpdateProxy<string>;
    subPrograms: SubPrograms;
    subProgramsUP: UpdateProxy<SubPrograms>;
    replaceWithProgram?: (toolProgram: ToolProgram) => void;
    subResults: {
        [id: string]: ToolResult;
    };
    varBindings: VarBindings;
    autoFocus?: boolean;
    onBlur?: () => void;
};
export declare const FancyCodeEditor: import("react").NamedExoticComponent<FancyCodeEditorProps>;
export declare const FancyCodeEditorWithScopeVarBindingsRef: import("react").NamedExoticComponent<FancyCodeEditorProps & {
    scopeVarBindingsRef: React.MutableRefObject<VarBindings>;
}>;
export declare function refCompletions(varBindingsGetter?: () => VarBindings | undefined): CompletionSource;
export declare function toolCompletions(context: EngraftContext, insertTool: (tool: Tool) => string, replaceWithTool?: (tool: Tool) => void): CompletionSource;
export declare const toolCompletionsTheme: Extension;
export {};
//# sourceMappingURL=FancyCodeEditor.d.ts.map