import { WidgetType } from "@codemirror/view";
export declare class PortalWidget<T> extends WidgetType {
    readonly portalSet: PortalSet<T>;
    readonly data: T;
    elem?: HTMLSpanElement;
    constructor(portalSet: PortalSet<T>, data: T);
    eq(otherWidget: PortalWidget<T>): boolean;
    toDOM(): HTMLSpanElement;
    destroy(): void;
}
export declare class PortalSet<T> {
    readonly setPortals: (portals: [HTMLSpanElement, T][]) => void;
    private portalMap;
    constructor(setPortals: (portals: [HTMLSpanElement, T][]) => void);
    private portals;
    register(elem: HTMLSpanElement, data: T): void;
    unregister(elem: HTMLSpanElement): void;
}
export declare function usePortalSet<T>(): readonly [PortalSet<T>, [HTMLSpanElement, T][]];
//# sourceMappingURL=PortalWidget.d.ts.map